<template>
  <v-app>
    <v-main>
      <NavBar></NavBar>
      <v-divider :color="allSpacesByKontoId.color" role="presentation" class="divider-top"></v-divider>
      <PostSpace :kontoIdProp="this.$route.params.kontoId"></PostSpace>
      <WithdrawOrderSpace :kontoIdProp="this.$route.params.kontoId"></WithdrawOrderSpace>
      <!-- <v-container>
        <v-row class="justify-end">
        </v-row>
      </v-container> -->

      <v-container>
        <h2 style="">{{ allSpacesByKontoId.name }}</h2>
        <h1 class="pt-2">€{{ accountBalance }}</h1>
        <p>Kontostand</p>
      </v-container>

      <v-container class="bg-surface-variant mb-6">

      <!-- Space Expansion Panels-->
        <template>
          <v-expansion-panels>
            <v-expansion-panel class="space-panel mt-6" v-for="(space, spaceId) in allSpacesByKontoId.spaces"
              :key="spaceId">
              <v-card-title class="blue white--text">
              </v-card-title>
              <v-expansion-panel-header class="space-panel-header" @click="showDeposit = false, showWithdraw = false">
                <v-row>
                  <v-col><h2>{{ space.name }}</h2></v-col>
                  <v-col>{{ space.description }} <br> <br>
                    {{ space.accountBalance }} Euro</v-col>
                </v-row>
                 <br>
                 <br>
              </v-expansion-panel-header>
              <v-expansion-panel-content>
                <v-btn color="red" class="mx-3" @click="deleteSpace(space.id)">Delete</v-btn>
                <v-btn color="green" class="mx-3" @click="showDeposit = true, showWithdraw = false">Deposit</v-btn>
                <v-btn color="blue" class="mx-3" @click="showWithdraw = true, showDeposit = false">Withdraw</v-btn>
                
                <!-- Deposit Form -->
                <div v-show="showDeposit">
                  <template>
                    <v-sheet width="300" class="mx-auto">
                      <v-form @submit.prevent>
                        <v-text-field v-model="spaceDeposit.amount"  label="Euro" type="number"></v-text-field>
                        <v-btn type="submit" block class="mt-2" @click="spaceDepositMethod(space.id)">Deposit</v-btn>
                      </v-form>
                    </v-sheet>
                  </template>
                </div>
                <!-- Withdraw Form -->
                <div v-show="showWithdraw">
                  <template>
                    <v-sheet width="300" class="mx-auto">
                      <v-form @submit.prevent>
                        <v-text-field v-model="spaceWithdraw.amount"  label="Euro" type="number"></v-text-field>
                        <v-btn type="submit" block class="mt-2" @click="spaceWithdrawMethod(space.id)">Withdraw</v-btn>
                      </v-form>
                    </v-sheet>
                  </template>
                </div>

              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
        </template>

      </v-container>
    </v-main>
  </v-app>
</template>
  
  <script>
  
    import NavBar from '../components/NavBar';
    import PostSpace from '@/components/PostSpace.vue';
    import WithdrawOrderSpace from '@/components/WithdrawOrderSpace.vue';
  
  export default {
    name: 'KontoDetail',
  
    components: {
      NavBar,
      PostSpace,
      WithdrawOrderSpace
    },
  
    data() {
      return {
        kontoId: this.$route.params.kontoId,

        deleteSpaceDetails: {
          kontoId: null,
          spaceId: null
        },
        showDeposit: null,
        showWithdraw: null,

        spaceDeposit: {
          spaceId: null,
          amount: null,
          kontoId: this.$route.params.kontoId
        },
        spaceWithdraw: {
          spaceId: null,
          amount: null,
          kontoId: this.$route.params.kontoId
        },
        
      }
    },
  
    computed: {
      allKontoOverview() {
        return this.$store.state.allKontoOverview;
      },
      allSpacesByKontoId() {
        return this.$store.state.allSpacesByKontoId;
      },
      accountBalance() {
        return this.$store.state.accountBalance;
      }
    },
  
    mounted() {
      this.getAllSpacesByKontoId();
      console.log("hello", this.kontoId);
      this.$store.dispatch("getAccountBalance", this.kontoId);
    },
      
    methods: {
      getAllSpacesByKontoId() {
        this.$store.dispatch("getAllSpaceByKontoId", this.kontoId);
      },
  
      togglePostKontoDialog() {
        this.$store.state.postKontoDialog = "true"
      },
      
      deleteSpace(spaceId) {
        this.deleteSpaceDetails.spaceId = spaceId;
        this.deleteSpaceDetails.kontoId = this.kontoId;
        this.$store.dispatch("deleteSpace", this.deleteSpaceDetails);
      },

      async spaceDepositMethod(spaceId) {
        this.spaceDeposit.spaceId = spaceId;
        await this.$store.dispatch("spaceDeposit", this.spaceDeposit).then(() => {
          this.spaceDeposit.spaceId = null
          this.spaceDeposit.amount = null
        }) 
      },

      async spaceWithdrawMethod(spaceId) {
        this.spaceWithdraw.spaceId = spaceId;
        await this.$store.dispatch("spaceWithdraw", this.spaceWithdraw).then(() => {
          this.spaceWithdraw.spaceId = null
          this.spaceWithdraw.amount = null
        })
      }
      
    }
  };
  </script>

  <style scoped>

    .space-panel-header {
        min-height: 150px;
    }

    .space-panel {
        max-width: 100%;
    }

    .konto-detail-card {
      padding: 2%;
      text-align: center;
    }

    .divider-top {
      padding: 15px;
    }
  </style>
  